]> git.proxmox.com Git - mirror_qemu.git/blame_incremental - Makefile
spapr: Add drc_ prefix to the DRC realize and unrealize functions
[mirror_qemu.git] / Makefile
... / ...
CommitLineData
1# Makefile for QEMU.
2
3ifneq ($(words $(subst :, ,$(CURDIR))), 1)
4 $(error main directory cannot contain spaces nor colons)
5endif
6
7# Always point to the root of the build tree (needs GNU make).
8BUILD_DIR=$(CURDIR)
9
10# Before including a proper config-host.mak, assume we are in the source tree
11SRC_PATH=.
12
13# Don't use implicit rules or variables
14# we have explicit rules for everything
15MAKEFLAGS += -rR
16
17SHELL = /usr/bin/env bash -o pipefail
18
19# Usage: $(call quiet-command,command and args,"NAME","args to print")
20# This will run "command and args", and either:
21# if V=1 just print the whole command and args
22# otherwise print the 'quiet' output in the format " NAME args to print"
23# NAME should be a short name of the command, 7 letters or fewer.
24# If called with only a single argument, will print nothing in quiet mode.
25quiet-command-run = $(if $(V),,$(if $2,printf " %-7s %s\n" $2 $3 && ))$1
26quiet-@ = $(if $(V),,@)
27quiet-command = $(quiet-@)$(call quiet-command-run,$1,$2,$3)
28
29UNCHECKED_GOALS := %clean TAGS cscope ctags dist \
30 help check-help print-% \
31 docker docker-% vm-help vm-test vm-build-%
32
33all:
34.PHONY: all clean distclean recurse-all dist msi FORCE
35
36# Don't try to regenerate Makefile or configure
37# We don't generate any of them
38Makefile: ;
39configure: ;
40
41# All following code might depend on configuration variables
42ifneq ($(wildcard config-host.mak),)
43include config-host.mak
44
45git-submodule-update:
46.git-submodule-status: git-submodule-update config-host.mak
47Makefile: .git-submodule-status
48
49.PHONY: git-submodule-update
50
51git_module_status := $(shell \
52 cd '$(SRC_PATH)' && \
53 GIT="$(GIT)" ./scripts/git-submodule.sh status $(GIT_SUBMODULES); \
54 echo $$?; \
55)
56
57ifeq (1,$(git_module_status))
58ifeq (no,$(GIT_UPDATE))
59git-submodule-update:
60 $(call quiet-command, \
61 echo && \
62 echo "GIT submodule checkout is out of date. Please run" && \
63 echo " scripts/git-submodule.sh update $(GIT_SUBMODULES)" && \
64 echo "from the source directory checkout $(SRC_PATH)" && \
65 echo && \
66 exit 1)
67else
68git-submodule-update:
69 $(call quiet-command, \
70 (cd $(SRC_PATH) && GIT="$(GIT)" ./scripts/git-submodule.sh update $(GIT_SUBMODULES)), \
71 "GIT","$(GIT_SUBMODULES)")
72endif
73endif
74
75# 0. ensure the build tree is okay
76
77# Check that we're not trying to do an out-of-tree build from
78# a tree that's been used for an in-tree build.
79ifneq ($(realpath $(SRC_PATH)),$(realpath .))
80ifneq ($(wildcard $(SRC_PATH)/config-host.mak),)
81$(error This is an out of tree build but your source tree ($(SRC_PATH)) \
82seems to have been used for an in-tree build. You can fix this by running \
83"$(MAKE) distclean && rm -rf *-linux-user *-softmmu" in your source tree)
84endif
85endif
86
87# force a rerun of configure if config-host.mak is too old or corrupted
88ifeq ($(MESON),)
89.PHONY: config-host.mak
90x := $(shell rm -rf meson-private meson-info meson-logs)
91endif
92ifeq ($(NINJA),)
93.PHONY: config-host.mak
94x := $(shell rm -rf meson-private meson-info meson-logs)
95else
96export NINJA
97endif
98ifeq ($(wildcard build.ninja),)
99.PHONY: config-host.mak
100x := $(shell rm -rf meson-private meson-info meson-logs)
101endif
102ifeq ($(origin prefix),file)
103.PHONY: config-host.mak
104x := $(shell rm -rf meson-private meson-info meson-logs)
105endif
106
107# 1. ensure config-host.mak is up-to-date
108config-host.mak: $(SRC_PATH)/configure $(SRC_PATH)/pc-bios $(SRC_PATH)/VERSION
109 @echo config-host.mak is out-of-date, running configure
110 @if test -f meson-private/coredata.dat; then \
111 ./config.status --skip-meson; \
112 else \
113 ./config.status && touch build.ninja.stamp; \
114 fi
115
116# 2. meson.stamp exists if meson has run at least once (so ninja reconfigure
117# works), but otherwise never needs to be updated
118meson-private/coredata.dat: meson.stamp
119meson.stamp: config-host.mak
120 @touch meson.stamp
121
122# 3. ensure generated build files are up-to-date
123
124ifneq ($(NINJA),)
125Makefile.ninja: build.ninja
126 $(quiet-@){ \
127 echo 'ninja-targets = \'; \
128 $(NINJA) -t targets all | sed 's/:.*//; $$!s/$$/ \\/'; \
129 echo 'build-files = \'; \
130 $(NINJA) -t query build.ninja | sed -n '1,/^ input:/d; /^ outputs:/q; s/$$/ \\/p'; \
131 } > $@.tmp && mv $@.tmp $@
132-include Makefile.ninja
133
134# A separate rule is needed for Makefile dependencies to avoid -n
135build.ninja: build.ninja.stamp
136build.ninja.stamp: meson.stamp $(build-files)
137 $(NINJA) $(if $V,-v,) build.ninja && touch $@
138endif
139
140ifneq ($(MESON),)
141Makefile.mtest: build.ninja scripts/mtest2make.py
142 $(MESON) introspect --targets --tests --benchmarks | $(PYTHON) scripts/mtest2make.py > $@
143-include Makefile.mtest
144endif
145
146# 4. Rules to bridge to other makefiles
147
148ifneq ($(NINJA),)
149MAKE.n = $(findstring n,$(firstword $(MAKEFLAGS)))
150MAKE.k = $(findstring k,$(firstword $(MAKEFLAGS)))
151MAKE.q = $(findstring q,$(firstword $(MAKEFLAGS)))
152MAKE.nq = $(if $(word 2, $(MAKE.n) $(MAKE.q)),nq)
153NINJAFLAGS = $(if $V,-v) $(if $(MAKE.n), -n) $(if $(MAKE.k), -k0) \
154 $(filter-out -j, $(lastword -j1 $(filter -l% -j%, $(MAKEFLAGS)))) \
155
156ninja-cmd-goals = $(or $(MAKECMDGOALS), all)
157ninja-cmd-goals += $(foreach t, $(.tests), $(.test.deps.$t))
158
159makefile-targets := build.ninja ctags TAGS cscope dist clean uninstall
160# "ninja -t targets" also lists all prerequisites. If build system
161# files are marked as PHONY, however, Make will always try to execute
162# "ninja build.ninja".
163ninja-targets := $(filter-out $(build-files) $(makefile-targets), $(ninja-targets))
164.PHONY: $(ninja-targets) run-ninja
165$(ninja-targets): run-ninja
166
167# Use "| cat" to give Ninja a more "make-y" output. Use "+" to bypass the
168# --output-sync line.
169run-ninja: config-host.mak
170ifneq ($(filter $(ninja-targets), $(ninja-cmd-goals)),)
171 +$(quiet-@)$(if $(MAKE.nq),@:, $(NINJA) \
172 $(NINJAFLAGS) $(sort $(filter $(ninja-targets), $(ninja-cmd-goals))) | cat)
173endif
174endif
175
176# Force configure to re-run if the API symbols are updated
177ifeq ($(CONFIG_PLUGIN),y)
178config-host.mak: $(SRC_PATH)/plugins/qemu-plugins.symbols
179
180.PHONY: plugins
181plugins:
182 $(call quiet-command,\
183 $(MAKE) $(SUBDIR_MAKEFLAGS) -C contrib/plugins V="$(V)", \
184 "BUILD", "example plugins")
185endif # $(CONFIG_PLUGIN)
186
187else # config-host.mak does not exist
188config-host.mak:
189ifneq ($(filter-out $(UNCHECKED_GOALS),$(MAKECMDGOALS)),$(if $(MAKECMDGOALS),,fail))
190 @echo "Please call configure before running make!"
191 @exit 1
192endif
193endif # config-host.mak does not exist
194
195SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory --quiet)
196
197include $(SRC_PATH)/tests/Makefile.include
198
199all: recurse-all
200
201ROM_DIRS = $(addprefix pc-bios/, $(ROMS))
202ROM_DIRS_RULES=$(foreach t, all clean, $(addsuffix /$(t), $(ROM_DIRS)))
203# Only keep -O and -g cflags
204.PHONY: $(ROM_DIRS_RULES)
205$(ROM_DIRS_RULES):
206 $(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $(dir $@) V="$(V)" TARGET_DIR="$(dir $@)" $(notdir $@),)
207
208.PHONY: recurse-all recurse-clean
209recurse-all: $(addsuffix /all, $(ROM_DIRS))
210recurse-clean: $(addsuffix /clean, $(ROM_DIRS))
211
212######################################################################
213
214clean: recurse-clean
215 -$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) -t clean || :
216 -$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) clean-ctlist || :
217# avoid old build problems by removing potentially incorrect old files
218 rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
219 find . \( -name '*.so' -o -name '*.dll' -o -name '*.[oda]' \) -type f \
220 ! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-aarch64.a \
221 ! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-arm.a \
222 -exec rm {} +
223 rm -f TAGS cscope.* *.pod *~ */*~
224 rm -f fsdev/*.pod scsi/*.pod
225
226VERSION = $(shell cat $(SRC_PATH)/VERSION)
227
228dist: qemu-$(VERSION).tar.bz2
229
230qemu-%.tar.bz2:
231 $(SRC_PATH)/scripts/make-release "$(SRC_PATH)" "$(patsubst qemu-%.tar.bz2,%,$@)"
232
233distclean: clean
234 -$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) -t clean -g || :
235 rm -f config-host.mak config-host.h*
236 rm -f tests/tcg/config-*.mak
237 rm -f config-all-disas.mak config.status
238 rm -f tests/qemu-iotests/common.env
239 rm -f roms/seabios/config.mak roms/vgabios/config.mak
240 rm -f qemu-plugins-ld.symbols qemu-plugins-ld64.symbols
241 rm -f *-config-target.h *-config-devices.mak *-config-devices.h
242 rm -rf meson-private meson-logs meson-info compile_commands.json
243 rm -f Makefile.ninja Makefile.mtest build.ninja.stamp meson.stamp
244 rm -f config.log
245 rm -f linux-headers/asm
246 rm -Rf .sdk
247
248find-src-path = find "$(SRC_PATH)/" -path "$(SRC_PATH)/meson" -prune -o \( -name "*.[chsS]" -o -name "*.[ch].inc" \)
249
250.PHONY: ctags
251ctags:
252 rm -f "$(SRC_PATH)/"tags
253 $(find-src-path) -exec ctags -f "$(SRC_PATH)/"tags --append {} +
254
255.PHONY: TAGS
256TAGS:
257 rm -f "$(SRC_PATH)/"TAGS
258 $(find-src-path) -exec etags -f "$(SRC_PATH)/"TAGS --append {} +
259
260.PHONY: cscope
261cscope:
262 rm -f "$(SRC_PATH)"/cscope.*
263 $(find-src-path) -print | sed -e 's,^\./,,' > "$(SRC_PATH)/cscope.files"
264 cscope -b -i"$(SRC_PATH)/cscope.files" -f"$(SRC_PATH)"/cscope.out
265
266# Needed by "meson install"
267export DESTDIR
268
269include $(SRC_PATH)/tests/docker/Makefile.include
270include $(SRC_PATH)/tests/vm/Makefile.include
271
272print-help-run = printf " %-30s - %s\\n" "$1" "$2"
273print-help = @$(call print-help-run,$1,$2)
274
275.PHONY: help
276help:
277 @echo 'Generic targets:'
278 $(call print-help,all,Build all)
279 $(call print-help,dir/file.o,Build specified target only)
280 $(call print-help,install,Install QEMU, documentation and tools)
281 $(call print-help,ctags/TAGS,Generate tags file for editors)
282 $(call print-help,cscope,Generate cscope index)
283 $(call print-help,sparse,Run sparse on the QEMU source)
284 @echo ''
285ifeq ($(CONFIG_PLUGIN),y)
286 @echo 'Plugin targets:'
287 $(call print-help,plugins,Build the example TCG plugins)
288 @echo ''
289endif
290 @echo 'Cleaning targets:'
291 $(call print-help,clean,Remove most generated files but keep the config)
292 $(call print-help,distclean,Remove all generated files)
293 $(call print-help,dist,Build a distributable tarball)
294 @echo ''
295 @echo 'Test targets:'
296 $(call print-help,check,Run all tests (check-help for details))
297 $(call print-help,bench,Run all benchmarks)
298 $(call print-help,docker,Help about targets running tests inside containers)
299 $(call print-help,vm-help,Help about targets running tests inside VM)
300 @echo ''
301 @echo 'Documentation targets:'
302 $(call print-help,html man,Build documentation in specified format)
303 @echo ''
304ifdef CONFIG_WIN32
305 @echo 'Windows targets:'
306 $(call print-help,installer,Build NSIS-based installer for QEMU)
307ifdef CONFIG_QGA_MSI
308 $(call print-help,msi,Build MSI-based installer for qemu-ga)
309endif
310 @echo ''
311endif
312 $(call print-help,$(MAKE) [targets],(quiet build, default))
313 $(call print-help,$(MAKE) V=1 [targets],(verbose build))
314
315# will delete the target of a rule if commands exit with a nonzero exit status
316.DELETE_ON_ERROR:
317
318print-%:
319 @echo '$*=$($*)'